/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 4/14/2006; 12:14:13 AM

#include "All.h"

//Waypoints.c
void addWaypoints(short, long, long, long, long);





/*
	Initialize the whole Player structure
*/
static inline void initPlayer() {
	Player *p = &allocatedMem->p;
	p->x = p->map->startingCoordX;
	p->y =p->map->startingCoordY;	
	p->vx=0;
	p->vy=0;
	p->stearingAngle=0;
	p->angle= p->map->startingAngle;
	p->shiftedAngle=p->map->startingAngle<<2;
	p->speed=0;//Doesn't need to be initialized?
	p->shiftedSpeed=0;
	p->nextWaypoint=2;
	p->numberOfLapDone=0;
	p->hasFinishedRacing=FALSE;
	if (allocatedMem->saveFile==NULL) {
		p->bestFPL=9999;
	}
	else
	{
		Scores *s = &(allocatedMem->saveFile->scores[ p->mapNumber ]);
		p->bestFPL=(p->raceMode==THREE_LAPS?s->best3Laps:s->bestLap);
	}
	p->currentFPL=0;
	
	

	
}

/*

*/
static inline void initializeGhostRecorder() {
	allocatedMem->writeGhostVariables.data = allocatedMem->gkp.data;
	allocatedMem->writeGhostVariables.ghostDataKeys = 0;
	allocatedMem->writeGhostVariables.ghostDataTime = 0;
	allocatedMem->writeGhostVariables.length = 0;
}

/*

*/
static inline void initializeGhostReader() {
	allocatedMem->readGhostVariables.data = allocatedMem->saveFile->ghostSave[ allocatedMem->p.mapNumber ].gkp.data;
	allocatedMem->readGhostVariables.ghostDataKeys = 0;
	allocatedMem->readGhostVariables.ghostDataTime = 0;
	allocatedMem->readGhostVariables.length = allocatedMem->saveFile->ghostSave[ allocatedMem->p.mapNumber ].length;
}


/*

*/
static inline void initGhost() {
	if (allocatedMem->p.raceMode == THREE_LAPS && allocatedMem->saveFile!=NULL) {
		allocatedMem->playGhost = allocatedMem->saveFile->ghostSave[allocatedMem->p.mapNumber].hasContent&&allocatedMem->saveFile->wantToShowGhost;
		allocatedMem->recordGhost = TRUE;
	}
	else
	{
		allocatedMem->playGhost = FALSE;
		allocatedMem->recordGhost = FALSE;
		return;
	}
	memcpy(&allocatedMem->ghostPlayer,&allocatedMem->p,sizeof(Player));
	initializeGhostRecorder();
	initializeGhostReader();
}

/*
	Initialize all the explosions

static inline void initExplosions() {
	memset(allocatedMem->explosions,0,NUMBER_OF_EXPLOSIONS*sizeof(Explosion));
}
*/

/*
	Initialize the waypoints
*/
static inline void initWaypoints() {
	memset(allocatedMem->waypointArray,0,128*128);
	unsigned char *ptr = allocatedMem->p.map->waypoints;
	int i=0;
	while (ptr[0] != 0 && ptr[1] != 0) {
		i++;
		addWaypoints(i, ptr[0]+32, ptr[1]+32, ptr[2]+32, ptr[3]+32);
		ptr+=4;
	}
	allocatedMem->p.numberOfWaypoints = i;	
}


/*
	Initialize the map: Copy a 64x64 array into a 128x128 one representing the array and initialize the waypoints
*/
static inline void initMap() {
	memset(allocatedMem->map,WHITE_TILE,128*128);
	short i;
	for (i=0;i<64;i++)
	memcpy(&(allocatedMem->map[i+32][32]),&(allocatedMem->p.map->array[i][0]),64);
	initWaypoints();
}


/*

*/
void initAll() {
	initPlayer();
	initGhost();//Must be placed after initPlayer()
	//initExplosions();
	initMap();
	
	allocatedMem->saveFile->scores[allocatedMem->p.mapNumber].attemps++;
}

